# SIEM connector

## Table of contents
[Requirements](#requirements)<br>
[Connector description](#connector-description)<br>
[Example of log file](#example-of-log-file)<br>
[Siem configuration](#siem-configuration)<br>
[Syslog configuration](#syslog-configuration)<br>
[Example of warden configuration](#example-of-warden-configuration)<br>
[IDEA format sent to warden](#idea-format-sent-to-warden)<br>
[Generator instructions](#generator-instructions)<br>
- - - -
## Requirements
1. Platform: 
    * Python 2.7+
2. Python packages: 
    *warden_client 3.0+
3. Properly configured Syslog Server and SIEM Server (all can be simulated by provided data [generator](#generator-instructions) for testing)

Also, the connector should already be registered as sending client on a Warden server (Protective node). This means you should know/have:

* URL of the Warden server
* Client name
* Client certificate and corresponding private key (cert.pem, key.pem)
* (Server certificate (e.g. server.crt.pem), if the Warden server uses self-signed certificate)

You can use warden_client available in connector repository. Alternatively, install warden_client library from repository. Download the Warden repository from GitLab (e.g. to your home) and copy the warden_client package to the site-packages folder of your Python installation. The exact destination path depends on the OS type and Python version used.
```
git clone git@gitlab.com:protective-h2020-eu/ti-s/Warden/Warden.git
sudo cp Warden/warden_client/warden_client.py /usr/lib64/python2.7/site-packages/
```

## Connector description
siem_connector.py is a **python script**, **reading logfile** generated by **Syslog Server** (/var/log/siem.log), **parsing it to IDEA** format and sending to warden **using warden-client**. It is a script, so it should be run for example once a week.
To know, where connector ended up reading log file, last_run.log is created where this information is stored (last processed log time). It starts parsing from the log after this date. 
* if last_run.log does not exist - all logs are parsed. 
* if last_run.log contains date earlier than first log in logfile - all logs are parsed.
* if last_run.log contains date later than last log in logfile - no logs are parsed.
* else logs are parsed from the date after this in last_run.log (if there is not such log, no logs are parsed)

SIEM logs have to be sent to file (/var/log/siem.log). Connector should be run on machine, where Syslog Server or Log Generator put logs.

**Note:** to change the location, where SIEM connector tries to find logs, please change field *logfile* in siem_connector.py script.

## Example of log file:
```
Oct 18 10:15:08 10.0.0.217 McAfee_SIEM: {"source":{"id":144115188075855872,"name":"Local ESM","subnet":"::ffff:127.0.0.1/128"},"data":{"unique_id":719844,"alert_id":1373,"thirdpartytype":306,"sig":{"id":2,"name":"Backup Performed"},"norm_sig":{"id":1347420160,"name":"Backup"},"action":"13","src_ip":"0.0.0.0","dst_ip":"0.0.0.0","src_port":0,"dst_port":0,"protocol":"n/a","src_mac":"00:00:00:00:00:00","dst_mac":"00:00:00:00:00:00","firsttime":"2017-10-18T10:15:08Z","lasttime":"2017-10-18T10:15:08Z","writetime":"2017-10-18T10:15:08Z","src_guid":"","dst_guid":"","total_severity":31,"severity":31,"eventcount":1,"flow":"0","vlan":"0","sequence":0,"trusted":2,"session_id":0,"compression_level":0,"reviewed":0}}
Oct 18 10:15:08 10.0.0.217 McAfee_SIEM: {"source":{"id":144115188075855872,"name":"Local ESM","subnet":"::ffff:127.0.0.1/128"},"data":{"unique_id":719844,"alert_id":1373,"thirdpartytype":306,"sig":{"id":2,"name":"Backup Performed"},"norm_sig":{"id":1347420160,"name":"Backup"},"action":"13","src_ip":"0.0.0.0","dst_ip":"0.0.0.0","src_port":0,"dst_port":0,"protocol":"n/a","src_mac":"00:00:00:00:00:00","dst_mac":"00:00:00:00:00:00","firsttime":"2017-10-18T10:15:08Z","lasttime":"2017-10-18T10:15:08Z","writetime":"2017-10-18T10:15:08Z","src_guid":"","dst_guid":"","total_severity":31,"severity":31,"eventcount":1,"flow":"0","vlan":"0","sequence":0,"trusted":2,"session_id":0,"compression_level":0,"reviewed":0}}
```
/var/log/siem.log should be updated by Syslog Server. 

## Siem configuration
To forward events to Syslog, proper settings have to be set in McAfee Enterprise Security Manager. 

In System Properties -> Event Forwarding, new destination should be added. Example configuration is showed bellow:

```
Name: <LogServerName>
Enabled: true
Format: Syslog (Standard Event Format)
Destination IP: <LogServerIP>
Destination Port: <LogServerPort>
Protocol: UDP
Facility: User
Severity: Informational
```

## Syslog configuration
.# cat /etc/rsyslog.conf | grep McAfee_SIEM (all our SIEM logs contain "McAfee_SIEM")
```
 *.info;mail.none;authpriv.none;cron.none, contains, "McAfee_SIEM"
 /var/log/siem.log
```
.# cat /etc/logrotate.conf
```
 /var/log/messeges.log
 {
         rotate 6
         monthly
         missingok
         notifempty
         delaycompress
         compress
         postrotate
         invoke-rc.d rsyslog rotate > /dev/null
         endscript
  }

 /var/log/siem.log
 {
         rotate 6
         monthly
         missingok
         notifempty
         delaycompress
         compress
         postrotate
         invoke-rc.d rsyslog rotate > /dev/null
         endscript
  }
```
Running script every 5 min:
```
*/5 *   * * *   root    /usr/bin/python
/opt/warden3-siem/siem_connector.py &>>
/var/log/siem_connector.log
```

## Example of warden configuration
To send data properly into Warden and Mentat, proper configuration of warden-client is needed. To do so, warden_client-siem.cfg file needs to be modified. Replace WARDEN_SERVER_URL, WARDEN_CLIENT_NAME and paths to certificates with appropriate values:
```
{
    "warden": "warden_client.cfg",
    "name": "WARDEN_CLIENT_NAME",
 
    # secret to authenticate client, if 'secret' is non empty, is used instead of value in client's configuration - useful while using more sensors with single client's configuration
    #"secret" = "siem_secret"
    # values: no (default)| yes (anonymize to 'target_net')| omit (completely omit target field)
    "anonymised": "no",
    #"target_net": "10.10.1.1/16",
    # aggregation window, e.g. 5 for events in the last 5 minutes
    "awin": 5
}
```
What's more, warden_client.cfg should be edited (name from warden_client-siem.cfg and warden_client.cfg should be the same):
```
{
    "url": "WARDEN_SERVER_URL",
    "certfile": "/warden_client_keys/cert.pem",
    "keyfile": "/warden_client_keys/key.pem",
    "cafile": "/warden_client_keys/ca.pem",
    "timeout": 60,
    "get_events_limit": 1000,
    "errlog": {"level": "debug"},
    "filelog": {"level": "debug", "file": "/var/log/warden_filer.log"},
    "name": "WARDEN_CLIENT_NAME"
}
```

## IDEA format sent to warden
```json
{"Format": "IDEA0",
 "ID": "a8298f87-8f11-47e3-9efa-3853126925db",
 "DetectTime": "2017-10-18 10:15:08",
 "CreateTime": "2017-10-31 09:42:49",
 "Category": 31,
 "Source":[
     {"IP4": ["0.0.0.0"],
     "MAC": "00:00:00:00:00:00",
     "Proto": ["n/a"],
     "Port": [0]}],
 "Target": [
     {"Anonymised": true, 
     "IP4": ["1.0.0.0/0"], 
     "MAC": "00:00:00:00:00:00", 
     "Proto": ["n/a"], 
     "Port": [0]}], 
 "Node": [
     {"Name": "pl.psnc.SIEM", 
     "Type": ["McAfee_SIEM"]}]}
```

## Generator instructions
To produce some logs for testing, special generator has been implemented. It can continuously generate logs to specified file.
### Generator configuration
To run generator, cfg file needs to be configured.
```
output - output dir
min_sleep - minimum break between logs (in seconds)
max_sleep - maximum break between logs (in seconds)(break is selected randomly)
real_sleep - (true/false) if false, breaks between logs are only simulated (break time is added to previous log time), it's generated at once, if true - break take place, generator works in real time
max_logs - maximum amount of logs to generate
regular - json with information about regular logs (srcs, dsts, ports...)
anomaly - json with information about anomaly logs (srcs, dsts, ports...)
```
All the important fields (interpreted by connector) are found in the first column (in both regular and anomaly json). The values of the rest can be filled, but in current version of connector, they won't appear in IDEA log. All values should be inserted in the right list, from which generator will draw random value.

Anomaly log appears with frequency 1/100.

**Note**: to change the location, where SIEM connector tries to find logs, please change field *logfile* in siem_connector.py script to match with the output dir of generator.

### Running generator
To run generator, execute bash command:
```bash
python siem_generator.py
```
Make sure, that output directory exists and generator.cfg is placed in the same directory as siem_generator.py.

**Note:** for testing, generator and connector should be run on the same machine and output of the generator should be an input of the connector. Output of the generator can be set in generator.cfg, the input of connector script can be changed directly in siem_connector.py script in field *logfile*.